;
;	sum.asm  -  Compute sum of array of bytes
;
;	Author:   J. op den Brouw
;	Date:     24-aug-2010
;	Revised:  28-sep-2018
;	Version:  1.1
;	Status:   demo
;
;	This is an assembler version of the text book
;	example of computing the sum of a list of
;	byte integers. The list is 8 bytes long (signed)
;	and starts at SRAM address 0x0060.
;

.def	temp	=r16			; Temporary data
.def	index	=r17			; List index
.def	sum		=r18			; Sum value
.equ    list    =SRAM_START		; Start of list in SRAM, via include file
;.equ	list	=0x0060			; Alternative for start of list in SRAM
.equ	length	=8				; List length

.org	0x000

main:
		ldi		zl,low(list)	; Z reg points to list
		ldi		zh,high(list)	;
	
		ldi		index,1			; Set index to one
		ld		sum,z			; Load first in sum
		adiw	zh:zl,1			; Move pointer to next

while:
		cpi		index,length	; Did we reach the end?
		brge	ewhile			; If yes, branch out of here

do:
		ld		temp,z			; Get list[index]
		add		sum,temp		; Add to sum

		adiw	zh:zl,1			; Move pointer to next
		inc		index			; Increment index
		rjmp	while			; And do it again

ewhile:

forever:
		rjmp	forever			; Halt
